<?php
/*
Plugin Name: ELI's Related Posts Widget
Plugin URI: http://wordpress.ieonly.com/category/my-plugins/related-posts-widget/
Author: Eli Scheetz
Author URI: http://wordpress.ieonly.com/
Description: This is a Related Post Links Widget for the WordPress sidebar. It basically displays any number of links to Posts that are related to the current single post using any of the same Tags. Now you can also relate your posts using categories.
Version: 1.1.11.09
*/
$SPOSTARBUST_Version='1.1.11.09';
$_SESSION['eli_debug_microtime']['include(SPOSTARBUST)'] = microtime(true);
$SPOSTARBUST_plugin_dir='SPOSTARBUST';
/**
 * SPOSTARBUST Main Plugin File
 * @package SPOSTARBUST
*/
/*  Copyright 2011 Eli Scheetz (email: wordpress@ieonly.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function SPOSTARBUST_install() {
	global $wp_version;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_install_start'] = microtime(true);
	if (version_compare($wp_version, "2.6", "<")) {
		deactivate_plugins(basename(__FILE__));
		wp_die(__("This Plugin requires WordPress version 2.6 or higher"));
	}
$_SESSION['eli_debug_microtime']['SPOSTARBUST_install_end'] = microtime(true);
}
function SPOSTARBUST_display_header($pTitle) {
	global $SPOSTARBUST_plugin_dir, $SPOSTARBUST_plugin_home, $SPOSTARBUST_updated_images_path, $SPOSTARBUST_Version;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_header_start'] = microtime(true);
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
	$wait_img_URL = $SPOSTARBUST_settings_array['img_url'].'wait.gif';
	echo '<style>
	.rounded-corners {margin: 10px; padding: 10px; -webkit-border-radius: 10px; -moz-border-radius: 10px; border: 1px solid #000000;}
	.shadowed-box {box-shadow: -3px 3px 3px #666666; -moz-box-shadow: -3px 3px 3px #666666; -webkit-box-shadow: -3px 3px 3px #666666;}
	.sidebar-box {background-color: #CCCCCC;}
	.shadowed-text {text-shadow: #0000FF -1px 1px 1px;}
	#right-sidebar {float: right; width: 230px;}
	#main-section {margin-right: 250px;}
	</style>
	<h1>ELI\'s Related Posts '.$pTitle.'</h1>
	<div id="right-sidebar">
	<div id="pluginupdates" class="shadowed-box rounded-corners sidebar-box"><center><h3 class="shadowed-text">Plugin Updates</h3></center>
		<div id="findUpdates"><center>Searching for updates ...<br /><img src="'.$wait_img_URL.'" alt="Wait..." /><br /><input type="button" value="Cancel" onclick="document.getElementById(\'findUpdates\').innerHTML = \'Could not find server!\';" /></center></div>
	<script type="text/javascript" src="'.$SPOSTARBUST_plugin_home.$SPOSTARBUST_updated_images_path.'?JS='.$SPOSTARBUST_plugin_dir.'&v='.$SPOSTARBUST_Version.'"></script>
	</div>
	<div id="pluginlinks" class="shadowed-box rounded-corners sidebar-box"><center><h3 class="shadowed-text">Plugin Links</h3>
<table><tr><td>
<li><a target="_blank" href="'.$SPOSTARBUST_plugin_home.'category/my-plugins/related-posts-widget/">Plugin URI</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/'.strtolower($SPOSTARBUST_plugin_dir).'/faq/">Plugin FAQs</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/'.strtolower($SPOSTARBUST_plugin_dir).'/stats/">Plugin Stats</a>
</td></tr></table>
</center></div>
	<div id="authorlinks" class="shadowed-box rounded-corners sidebar-box"><center><h3 class="shadowed-text">Author Links</h3>Feed My Family:<br /><form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="8VWNB5QEJ55TJ">
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
<table><tr><td>
<li><a target="_blank" href="'.$SPOSTARBUST_plugin_home.'category/my-plugins/">ELI\'s Blog</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/profile/scheeeli">WordPress Profile</a>
</td></tr></table>
</center></div>
	</div>
	<div id="admin-page-container">
	<div id="main-section">';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_header_end'] = microtime(true);
}
function SPOSTARBUST_display_File($dFile) {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_File_start'] = microtime(true);
	if (file_exists(dirname(__FILE__).'/'.strtolower($dFile).'.txt')) {
		echo '<h2>'.$dFile.' File</h2><textarea disabled="yes" width="100%" style="width: 100%;" rows="20" class="shadowed-box">';
		include(strtolower($dFile).'.txt');
		echo '</textarea><br />';
	}
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_File_end'] = microtime(true);
}
function SPOSTARBUST_readme() {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_readme_start'] = microtime(true);
	SPOSTARBUST_display_header('Readme');
	SPOSTARBUST_display_File('Readme');
	echo '</div></div>';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_readme_end'] = microtime(true);
}
function SPOSTARBUST_license() {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_license_start'] = microtime(true);
	SPOSTARBUST_display_header('License');
	SPOSTARBUST_display_File('License');
	echo '</div></div>';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_license_end'] = microtime(true);
}
function SPOSTARBUST_menu() {
	global $SPOSTARBUST_plugin_dir, $SPOSTARBUST_Version, $SPOSTARBUST_plugin_home, $SPOSTARBUST_Logo_IMG, $SPOSTARBUST_updated_images_path;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_menu_start'] = microtime(true);
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
	$Logo_URL = $SPOSTARBUST_settings_array['img_url'].$SPOSTARBUST_Logo_IMG;
	$img_path = basename(__FILE__);
	$Logo_Path = 'images/'.$SPOSTARBUST_Logo_IMG;
	$Full_plugin_logo_URL = get_option('siteurl');
	$Full_plugin_logo_URL = $SPOSTARBUST_plugin_home.$SPOSTARBUST_updated_images_path.$img_path.'?v='.$SPOSTARBUST_Version.'&p='.$SPOSTARBUST_plugin_dir.'&d='.
	urlencode($Full_plugin_logo_URL);
	$Logo_URL = $Full_plugin_logo_URL;
	$base_page = $SPOSTARBUST_plugin_dir.'-readme';
	if (function_exists('add_object_page'))
		add_object_page(__('ELI\'s Related Posts - Readme File'), __('RelatedPosts'), 'administrator', $base_page, $SPOSTARBUST_plugin_dir.'_readme', $Logo_URL);
	else
		add_menu_page(__('ELI\'s Related Posts - Readme File'), __('RelatedPosts'), 'administrator', $base_page, $SPOSTARBUST_plugin_dir.'_readme', $Logo_URL);
	add_submenu_page($base_page, __('ELI\'s Related Posts - Readme File'), __('Readme Info'), 'administrator', $base_page, $SPOSTARBUST_plugin_dir.'_readme');
	add_submenu_page($base_page, __('ELI\'s Related Posts - License File'), __('License Info'), 'administrator', $SPOSTARBUST_plugin_dir.'-license', $SPOSTARBUST_plugin_dir.'_license');
$_SESSION['eli_debug_microtime']['SPOSTARBUST_menu_end'] = microtime(true);
}
function SPOSTARBUST_init() {
	global $SPOSTARBUST_plugin_dir;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_init_start'] = microtime(true);
	$img_url = plugins_url('/images/', __FILE__);
	$SPOSTARBUST_settings_array=array("img_url"=>$img_url);	
	update_option($SPOSTARBUST_plugin_dir.'_settings_array', $SPOSTARBUST_settings_array);
$_SESSION['eli_debug_microtime']['SPOSTARBUST_init_end'] = microtime(true);
}
class SPOSTARBUST_Widget_Class extends WP_Widget {
	function SPOSTARBUST_Widget_Class() {
		global $SPOSTARBUST_plugin_dir;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_Widget_Class_start'] = microtime(true);
		$this->WP_Widget($SPOSTARBUST_plugin_dir.'-Widget', __('Related Posts'), array('classname' => 'widget_'.$SPOSTARBUST_plugin_dir, 'description' => __('Linked list of related Posts by Tags or Categories')));
		$this->alt_option_name = 'widget_'.$SPOSTARBUST_plugin_dir;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_Widget_Class_end'] = microtime(true);
	}
	function widget($args, $instance) {
		global $post;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_widget_start'] = microtime(true);
		$global_post = $post;
		wp_reset_query();
		if (have_posts()) {
			the_post();
			$pID = $post->ID;
//			$pTitle = the_title('\"', '\"', false);
			$tags = array();
			extract($args);
			if (!$instance['title'])
				$instance['title'] = "Related Posts";
			if (!$instance['number'])
				$instance['number'] = 5;
			if (isset($instance['relateby']) && $instance['relateby'] == "category__in")
				$all_tags = get_the_category();
			else {
				$all_tags = get_the_tags();
				$instance['relateby'] = "tag__in";
			}
			if ($all_tags)
				foreach ($all_tags as $tag)
					$tags[] = $tag->term_id;
			if ((!have_posts()) && count($tags) > 0) {
				$tags_query = array('showposts' => $instance['number'], $instance['relateby'] => $tags,'post__not_in' => array("$pID"));
				query_posts($tags_query);
				$LIs = '';
				for ($p = 0; have_posts(); $p++) {
					the_post();
					if ($pID != $post->ID)
						$LIs .= the_title('<li class="SPOSTARBUST-Related-Post"><a title="', '" href="', false).get_permalink($post->ID).the_title('" rel="bookmark">', "</a></li>\n", false);
				}
				if (strlen($LIs) > 0)
					echo $before_widget.$before_title.$instance["title"].$after_title."<ul>\n".$LIs."</ul>\n".$after_widget;
			}
		}
		wp_reset_query();
		$post = $global_post;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_widget_end'] = microtime(true);
	}
	function flush_widget_cache() {
		global $SPOSTARBUST_plugin_dir;
		wp_cache_delete('widget_'.$SPOSTARBUST_plugin_dir, 'widget');
	}
	function update($new, $old) {
		$instance = $old;
		$instance['title'] = strip_tags($new['title']);
		$instance['number'] = (int) $new['number'];
		$instance['relateby'] = strip_tags($new['relateby']);
		return $instance;
	}
	function form( $instance ) {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_form_start'] = microtime(true);
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$relateby = isset($instance['relateby']) ? esc_attr($instance['relateby']) : 'tag__in';
		echo '<p><label for="'.$this->get_field_id('title').'">'.__('Alternative Title').':</label>
		<input type="text" name="'.$this->get_field_name('title').'" id="'.$this->get_field_id('title').'" value="'.$title.'" /></p>
		<p><label for="'.$this->get_field_id('number').'">Number of Posts to List:</label>
		<input type="text" size="2" name="'.$this->get_field_name('number').'" id="'.$this->get_field_id('number').'" value="'.$number.'" /></p>
		<p><label for="'.$this->get_field_id('relateby').'">'.__('Relate Posts by').':</label>
		<select name="'.$this->get_field_name('relateby').'" id="'.$this->get_field_id('relateby').'"><option value="tag__in">Tags</option><option value="category__in"'.($relateby=="category__in"?" selected":"").'>Categories</option></select></p>';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_form_end'] = microtime(true);
	}
}
$SPOSTARBUST_plugin_home='http://wordpress.ieonly.com/';
$SPOSTARBUST_updated_images_path='wp-content/plugins/UPDATE/images/';
$SPOSTARBUST_Logo_IMG='SPOSTARBUST-16x16.gif';
register_activation_hook(__FILE__,$SPOSTARBUST_plugin_dir.'_install');
add_action('widgets_init', create_function('', 'return register_widget("SPOSTARBUST_Widget_Class");'));
add_action('admin_init', $SPOSTARBUST_plugin_dir.'_init');
add_action('admin_menu', $SPOSTARBUST_plugin_dir.'_menu');
$_SESSION['eli_debug_microtime']['end_include(SPOSTARBUST)'] = microtime(true);
?>
